/************************** DISCLAIMER ********************************/
/*                                                                    */
/*   This file was generated on 03/22/01 09:35:59 by the version of   */
/*   ADIC compiled on  08/07/00 18:06:31                              */
/*                                                                    */
/*   ADIC was prepared as an account of work sponsored by an          */
/*   agency of the United States Government and the University of     */
/*   Chicago.  NEITHER THE AUTHOR(S), THE UNITED STATES GOVERNMENT    */
/*   NOR ANY AGENCY THEREOF, NOR THE UNIVERSITY OF CHICAGO, INCLUDING */
/*   ANY OF THEIR EMPLOYEES OR OFFICERS, MAKES ANY WARRANTY, EXPRESS  */
/*   OR IMPLIED, OR ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR */
/*   THE ACCURACY, COMPLETENESS, OR USEFULNESS OF ANY INFORMATION OR  */
/*   PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT INFRINGE */
/*   PRIVATELY OWNED RIGHTS.                                          */
/*                                                                    */
/**********************************************************************/
#include "ad_deriv.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "adintrinsics.h"
typedef double nosens_real;
typedef DERIV_TYPE  ad_real;
typedef int  integer;
#include "ad_mpi.h"
#define PVEC_REAL_MPI_TYPE MPI_DERIV_TYPE
void   *ad_PVecInitMPI(MPI_Comm  comm,int  local_vec_length,int  global_vec_length,int  *argc,char  ***argv);
void   ad_PVecFreeMPI(void   *machEnv);
struct ad_machEnvTypeStruct {
MPI_Comm  comm;
integer  local_vec_length;
integer  global_vec_length;
int  init_by_user;
}
;
typedef struct ad_machEnvTypeStruct *machEnvType;
typedef struct  {
integer  length;
integer  global_length;
DERIV_TYPE  *data;
machEnvType  machEnv;
void   *subptr;
}
*ad_N_Vector;
ad_N_Vector  ad_N_VNew(integer  Ntotal,machEnvType  machEnv);
void   ad_N_VFree(ad_N_Vector  x);
void   ad_N_VLinearSum(DERIV_TYPE  a,ad_N_Vector  x,DERIV_TYPE  b,ad_N_Vector  y,ad_N_Vector  z);
void   ad_N_VConst(DERIV_TYPE  c,ad_N_Vector  z);
void   ad_N_VProd(ad_N_Vector  x,ad_N_Vector  y,ad_N_Vector  z);
void   ad_N_VDiv(ad_N_Vector  x,ad_N_Vector  y,ad_N_Vector  z);
void   ad_N_VScale(DERIV_TYPE  c,ad_N_Vector  x,ad_N_Vector  z);
void   ad_N_VAbs(ad_N_Vector  x,ad_N_Vector  z);
void   ad_N_VInv(ad_N_Vector  x,ad_N_Vector  z);
void   ad_N_VAddConst(ad_N_Vector  x,DERIV_TYPE  b,ad_N_Vector  z);
void   ad_N_VDotProd(DERIV_TYPE  *ad_var_ret,ad_N_Vector  x,ad_N_Vector  y);
void   ad_N_VMaxNorm(DERIV_TYPE  *ad_var_ret,ad_N_Vector  x);
void   ad_N_VWrmsNorm(DERIV_TYPE  *ad_var_ret,ad_N_Vector  x,ad_N_Vector  w);
void   ad_N_VMin(DERIV_TYPE  *ad_var_ret,ad_N_Vector  x);
void   ad_N_VWL2Norm(DERIV_TYPE  *ad_var_ret,ad_N_Vector  x,ad_N_Vector  w);
void   ad_N_VL1Norm(DERIV_TYPE  *ad_var_ret,ad_N_Vector  x);
void   ad_N_VCompare(DERIV_TYPE  c,ad_N_Vector  x,ad_N_Vector  z);
int  ad_N_VInvTest(ad_N_Vector  x,ad_N_Vector  z);
int  ad_N_VConstrProdPos(ad_N_Vector  c,ad_N_Vector  x);
void   ad_N_VPrint(ad_N_Vector  x);
#include "ad_mpi.h"
typedef struct  {
DERIV_TYPE  om, dx, dy, q4;
DERIV_TYPE  uext[(2 * (5 + 2)) * (5 + 2)];
integer  my_pe, isubx, isuby, nvmxsub, nvmxsub2;
DERIV_TYPE  *p;
DERIV_TYPE  *pbar;
MPI_Comm  comm;
}
*ad_UserData;
void   ad_f_old(integer  N,nosens_real  t,ad_N_Vector  u,ad_N_Vector  udot,void   *f_data);
void   ad_flocal(integer  N,nosens_real  t,DERIV_TYPE  uarray[],DERIV_TYPE  duarray[],void   *f_data);
void   ad_ucomm(integer  N,nosens_real  t,ad_N_Vector  u,void   *f_data);
void   ad_UnitRoundoff(DERIV_TYPE  *ad_var_ret);
void   ad_RPowerI(DERIV_TYPE  *ad_var_ret,DERIV_TYPE  base,int  exponent);
void   ad_RPowerR(DERIV_TYPE  *ad_var_ret,DERIV_TYPE  base,DERIV_TYPE  exponent);
void   ad_RSqrt(DERIV_TYPE  *ad_var_ret,DERIV_TYPE  x);
#include "ad_mpi.h"
static void   ad_BSend(MPI_Comm  comm,integer  my_pe,integer  isubx,integer  isuby,integer  dsizex,integer  dsizey,DERIV_TYPE  uarray[]);
static void   ad_BRecvPost(MPI_Comm  comm,MPI_Request  request[],integer  my_pe,integer  isubx,integer  isuby,integer  dsizex,integer  dsizey,DERIV_TYPE  uext[],DERIV_TYPE  buffer[]);
static void   ad_BRecvWait(MPI_Request  request[],integer  isubx,integer  isuby,integer  dsizex,DERIV_TYPE  uext[],DERIV_TYPE  buffer[]);
static void   ad_fucomm(integer  N,nosens_real  t,ad_N_Vector  u,void   *f_data);
static void   ad_BSend(MPI_Comm  comm,integer  my_pe,integer  isubx,integer  isuby,integer  dsizex,integer  dsizey,DERIV_TYPE  uarray[]) {
int  i, ly;
integer  offsetu, offsetbuf;
DERIV_TYPE  bufleft[2 * 5], bufright[2 * 5];
int  ad_var_0, ad_var_1, ad_var_2, ad_var_3;
    if (isuby != 0)     {
        MPI_Send( &uarray[0], dsizex, PVEC_REAL_MPI_TYPE, my_pe - 2, 0, comm);
    }
    if (isuby != 2 - 1)     {
        offsetu = (5 - 1) * dsizex;
        MPI_Send( &uarray[offsetu], dsizex, PVEC_REAL_MPI_TYPE, my_pe + 2, 0, comm);
    }
    if (isubx != 0)     {
        for (ly = 0;         ly < 5;         )        {
            offsetbuf = ly * 2;
            offsetu = ly * dsizex;
            for (i = 0;             i < 2;             )            {
                {
                    ad_grad_axpy_copy(&(bufleft[offsetbuf + i]), &(uarray[offsetu + i]));
                    DERIV_val(bufleft[offsetbuf + i]) = DERIV_val(uarray[offsetu + i]);
                }
                ad_var_1 = i++;
            }
            ad_var_0 = ly++;
        }
        MPI_Send( &bufleft[0], dsizey, PVEC_REAL_MPI_TYPE, my_pe - 1, 0, comm);
    }
    if (isubx != 2 - 1)     {
        for (ly = 0;         ly < 5;         )        {
            offsetbuf = ly * 2;
            offsetu = offsetbuf * 5 + (5 - 1) * 2;
            for (i = 0;             i < 2;             )            {
                {
                    ad_grad_axpy_copy(&(bufright[offsetbuf + i]), &(uarray[offsetu + i]));
                    DERIV_val(bufright[offsetbuf + i]) = DERIV_val(uarray[offsetu + i]);
                }
                ad_var_3 = i++;
            }
            ad_var_2 = ly++;
        }
        MPI_Send( &bufright[0], dsizey, PVEC_REAL_MPI_TYPE, my_pe + 1, 0, comm);
    }
}
static void   ad_BRecvPost(MPI_Comm  comm,MPI_Request  request[],integer  my_pe,integer  isubx,integer  isuby,integer  dsizex,integer  dsizey,DERIV_TYPE  uext[],DERIV_TYPE  buffer[]) {
integer  offsetue;
DERIV_TYPE  *bufleft = buffer, *bufright = buffer + 2 * 5;
    if (isuby != 0)     {
        MPI_Irecv( &uext[2], dsizex, PVEC_REAL_MPI_TYPE, my_pe - 2, 0, comm,  &request[0]);
    }
    if (isuby != 2 - 1)     {
        offsetue = 2 * (1 + (5 + 1) * (5 + 2));
        MPI_Irecv( &uext[offsetue], dsizex, PVEC_REAL_MPI_TYPE, my_pe + 2, 0, comm,  &request[1]);
    }
    if (isubx != 0)     {
        MPI_Irecv( &bufleft[0], dsizey, PVEC_REAL_MPI_TYPE, my_pe - 1, 0, comm,  &request[2]);
    }
    if (isubx != 2 - 1)     {
        MPI_Irecv( &bufright[0], dsizey, PVEC_REAL_MPI_TYPE, my_pe + 1, 0, comm,  &request[3]);
    }
}
static void   ad_BRecvWait(MPI_Request  request[],integer  isubx,integer  isuby,integer  dsizex,DERIV_TYPE  uext[],DERIV_TYPE  buffer[]) {
int  i, ly;
integer  dsizex2, offsetue, offsetbuf;
DERIV_TYPE  *bufleft = buffer, *bufright = buffer + 2 * 5;
MPI_Status  status;
int  ad_var_0, ad_var_1, ad_var_2, ad_var_3;
    dsizex2 = dsizex + 2 * 2;
    if (isuby != 0)     {
        MPI_Wait( &request[0],  &status);
    }
    if (isuby != 2 - 1)     {
        MPI_Wait( &request[1],  &status);
    }
    if (isubx != 0)     {
        MPI_Wait( &request[2],  &status);
        for (ly = 0;         ly < 5;         )        {
            offsetbuf = ly * 2;
            offsetue = (ly + 1) * dsizex2;
            for (i = 0;             i < 2;             )            {
                {
                    ad_grad_axpy_copy(&(uext[offsetue + i]), &(bufleft[offsetbuf + i]));
                    DERIV_val(uext[offsetue + i]) = DERIV_val(bufleft[offsetbuf + i]);
                }
                ad_var_1 = i++;
            }
            ad_var_0 = ly++;
        }
    }
    if (isubx != 2 - 1)     {
        MPI_Wait( &request[3],  &status);
        for (ly = 0;         ly < 5;         )        {
            offsetbuf = ly * 2;
            offsetue = (ly + 2) * dsizex2 - 2;
            for (i = 0;             i < 2;             )            {
                {
                    ad_grad_axpy_copy(&(uext[offsetue + i]), &(bufright[offsetbuf + i]));
                    DERIV_val(uext[offsetue + i]) = DERIV_val(bufright[offsetbuf + i]);
                }
                ad_var_3 = i++;
            }
            ad_var_2 = ly++;
        }
    }
}
static void   ad_fucomm(integer  N,nosens_real  t,ad_N_Vector  u,void   *f_data) {
ad_UserData  data;
DERIV_TYPE  *uarray, *uext, buffer[(2 * 2) * 5];
MPI_Comm  comm;
integer  my_pe, isubx, isuby, nvmxsub, nvmysub;
MPI_Request  request[4];
ad_UserData  ad_var_0;
    ad_var_0 = (ad_UserData )f_data;
    data = ad_var_0;
    uarray = u->data;
    comm = data->comm;
    my_pe = data->my_pe;
    isubx = data->isubx;
    isuby = data->isuby;
    nvmxsub = data->nvmxsub;
    nvmysub = 2 * 5;
    uext = data->uext;
    ad_BRecvPost(comm, request, my_pe, isubx, isuby, nvmxsub, nvmysub, uext, buffer);
    ad_BSend(comm, my_pe, isubx, isuby, nvmxsub, nvmysub, uarray);
    ad_BRecvWait(request, isubx, isuby, nvmxsub, uext, buffer);
}
void   ad_f(integer  N,nosens_real  t,ad_N_Vector  u,ad_N_Vector  udot,void   *f_data) {
DERIV_TYPE  *uarray, *duarray;
ad_UserData  data;
ad_UserData  ad_var_0;
    uarray = u->data;
    duarray = udot->data;
    ad_var_0 = (ad_UserData )f_data;
    data = ad_var_0;
    ad_fucomm(N, t, u, data);
    ad_flocal(N, t, uarray, duarray, data);
}
void   ad_flocal(integer  N,nosens_real  t,DERIV_TYPE  uarray[],DERIV_TYPE  duarray[],void   *f_data) {
DERIV_TYPE  *uext;
DERIV_TYPE  q3, c1, c2, c1dn, c2dn, c1up, c2up, c1lt, c2lt;
DERIV_TYPE  c1rt, c2rt, cydn, cyup, hord1, hord2, horad1, horad2;
DERIV_TYPE  qq1, qq2, qq3, qq4, rkin1, rkin2, s, vertd1, vertd2, ydn, yup;
DERIV_TYPE  q4coef, dely, verdco, hordco, horaco;
int  i, lx, ly, jx, jy;
integer  isubx, isuby, nvmxsub, nvmxsub2, offsetu, offsetue;
ad_UserData  data;
DERIV_TYPE  Q1, Q2, C3, A3, A4, KH, VEL, KV0;
ad_UserData  ad_var_0;
int  ad_var_1, ad_var_2, ad_var_3, ad_var_4, ad_var_5, ad_var_6, ad_var_7, ad_var_8, ad_var_12, ad_var_17;
DERIV_TYPE  ad_var_9, ad_var_10, ad_var_11, ad_var_13, ad_var_15;
DERIV_TYPE  ad_var_14, ad_var_16;
double  ad_adji_0;
    double  ad_loc_0;
    double  ad_loc_1;
    double  ad_loc_2;
    double  ad_adj_0;
    double  ad_adj_1;
    double  ad_adj_2;
    double  ad_adj_3;
    double  ad_loc_3;
    double  ad_loc_4;

        static int g_filenum = 0;
        if (g_filenum == 0) {
            adintr_ehsfid(&g_filenum, __FILE__, "ad_flocal");
        }
            ad_var_0 = (ad_UserData )f_data;
    data = ad_var_0;
    {
        ad_grad_axpy_copy(&(Q1), &(data->p[0]));
        DERIV_val(Q1) = DERIV_val(data->p[0]);
    }
    {
        ad_grad_axpy_copy(&(Q2), &(data->p[1]));
        DERIV_val(Q2) = DERIV_val(data->p[1]);
    }
    {
        ad_grad_axpy_copy(&(C3), &(data->p[2]));
        DERIV_val(C3) = DERIV_val(data->p[2]);
    }
    {
        ad_grad_axpy_copy(&(A3), &(data->p[3]));
        DERIV_val(A3) = DERIV_val(data->p[3]);
    }
    {
        ad_grad_axpy_copy(&(A4), &(data->p[4]));
        DERIV_val(A4) = DERIV_val(data->p[4]);
    }
    {
        ad_grad_axpy_copy(&(KH), &(data->p[5]));
        DERIV_val(KH) = DERIV_val(data->p[5]);
    }
    {
        ad_grad_axpy_copy(&(VEL), &(data->p[6]));
        DERIV_val(VEL) = DERIV_val(data->p[6]);
    }
    {
        ad_grad_axpy_copy(&(KV0), &(data->p[7]));
        DERIV_val(KV0) = DERIV_val(data->p[7]);
    }
    isubx = data->isubx;
    isuby = data->isuby;
    nvmxsub = data->nvmxsub;
    nvmxsub2 = data->nvmxsub2;
    uext = data->uext;
    offsetu = 0;
    offsetue = nvmxsub2 + 2;
    for (ly = 0;     ly < 5;     )    {
        for (i = 0;         i < nvmxsub;         )        {
            {
                ad_grad_axpy_copy(&(uext[offsetue + i]), &(uarray[offsetu + i]));
                DERIV_val(uext[offsetue + i]) = DERIV_val(uarray[offsetu + i]);
            }
            ad_var_2 = i++;
        }
        offsetu = offsetu + nvmxsub;
        offsetue = offsetue + nvmxsub2;
        ad_var_1 = ly++;
    }
    if (isuby == 0)     {
        for (i = 0;         i < nvmxsub;         )        {
            {
                ad_grad_axpy_copy(&(uext[2 + i]), &(uarray[nvmxsub + i]));
                DERIV_val(uext[2 + i]) = DERIV_val(uarray[nvmxsub + i]);
            }
            ad_var_3 = i++;
        }
    }
    if (isuby == 2 - 1)     {
        offsetu = (5 - 2) * nvmxsub;
        offsetue = (5 + 1) * nvmxsub2 + 2;
        for (i = 0;         i < nvmxsub;         )        {
            {
                ad_grad_axpy_copy(&(uext[offsetue + i]), &(uarray[offsetu + i]));
                DERIV_val(uext[offsetue + i]) = DERIV_val(uarray[offsetu + i]);
            }
            ad_var_4 = i++;
        }
    }
    if (isubx == 0)     {
        for (ly = 0;         ly < 5;         )        {
            offsetu = ly * nvmxsub + 2;
            offsetue = (ly + 1) * nvmxsub2;
            for (i = 0;             i < 2;             )            {
                {
                    ad_grad_axpy_copy(&(uext[offsetue + i]), &(uarray[offsetu + i]));
                    DERIV_val(uext[offsetue + i]) = DERIV_val(uarray[offsetu + i]);
                }
                ad_var_6 = i++;
            }
            ad_var_5 = ly++;
        }
    }
    if (isubx == 2 - 1)     {
        for (ly = 0;         ly < 5;         )        {
            offsetu = (ly + 1) * nvmxsub - 2 * 2;
            offsetue = (ly + 2) * nvmxsub2 - 2;
            for (i = 0;             i < 2;             )            {
                {
                    ad_grad_axpy_copy(&(uext[offsetue + i]), &(uarray[offsetu + i]));
                    DERIV_val(uext[offsetue + i]) = DERIV_val(uarray[offsetu + i]);
                }
                ad_var_8 = i++;
            }
            ad_var_7 = ly++;
        }
    }
    {
        ad_grad_axpy_copy(&(dely), &(data->dy));
        DERIV_val(dely) = DERIV_val(data->dy);
    }
    {
        ad_loc_0 = DERIV_val(data->dy) * DERIV_val(data->dy);
        ad_loc_1 = 1.0 / ad_loc_0;
        ad_loc_2 = ad_loc_1 * DERIV_val(KV0);
        ad_adj_0 = ( -ad_loc_1 / ad_loc_0) * DERIV_val(KV0);
        ad_adj_1 = DERIV_val(data->dy) * ad_adj_0;
        ad_adj_2 = DERIV_val(data->dy) * ad_adj_0;
        ad_grad_axpy_3(&(verdco), ad_adj_2, &(data->dy), ad_adj_1, &(data->dy), ad_loc_1, &(KV0));
        DERIV_val(verdco) = ad_loc_2;
    }
    {
        ad_loc_0 = DERIV_val(data->dx) * DERIV_val(data->dx);
        ad_loc_1 = DERIV_val(KH) / ad_loc_0;
        ad_adj_0 =  -ad_loc_1 / ad_loc_0;
        ad_adj_1 = 1.000000000000000e+00 / ad_loc_0;
        ad_adj_2 = DERIV_val(data->dx) * ad_adj_0;
        ad_adj_3 = DERIV_val(data->dx) * ad_adj_0;
        ad_grad_axpy_3(&(hordco), ad_adj_1, &(KH), ad_adj_3, &(data->dx), ad_adj_2, &(data->dx));
        DERIV_val(hordco) = ad_loc_1;
    }
    {
        ad_loc_0 = 2.0 * DERIV_val(data->dx);
        ad_loc_1 = DERIV_val(VEL) / ad_loc_0;
        ad_adj_0 =  -ad_loc_1 / ad_loc_0;
        ad_adj_1 = 1.000000000000000e+00 / ad_loc_0;
        ad_adj_2 = 2.0 * ad_adj_0;
        ad_grad_axpy_2(&(horaco), ad_adj_1, &(VEL), ad_adj_2, &(data->dx));
        DERIV_val(horaco) = ad_loc_1;
    }
    {
        ad_loc_0 = DERIV_val(data->om) * t;
        ad_grad_axpy_1(&(ad_var_9), t, &(data->om));
        DERIV_val(ad_var_9) = ad_loc_0;
    }
     DERIV_val(s) = sin( DERIV_val(ad_var_9)); /*sin*/
      ad_adji_0 = cos( DERIV_val(ad_var_9));
    {
        ad_grad_axpy_1(&(s), ad_adji_0, &(ad_var_9));
    }
    if (DERIV_val(s) > 0.0)     {
        {
            ad_loc_0 =  -DERIV_val(A3);
            ad_loc_1 = ad_loc_0 / DERIV_val(s);
            ad_adj_0 =  -ad_loc_1 / DERIV_val(s);
            ad_adj_1 = 1.000000000000000e+00 / DERIV_val(s);
            ad_adj_2 =  -ad_adj_1;
            ad_grad_axpy_2(&(ad_var_10), ad_adj_2, &(A3), ad_adj_0, &(s));
            DERIV_val(ad_var_10) = ad_loc_1;
        }
     DERIV_val(q3) = exp( DERIV_val(ad_var_10));  /*exp*/
      ad_adji_0 = DERIV_val(q3);
        {
            ad_grad_axpy_1(&(q3), ad_adji_0, &(ad_var_10));
        }
        {
            ad_loc_0 =  -DERIV_val(A4);
            ad_loc_1 = ad_loc_0 / DERIV_val(s);
            ad_adj_0 =  -ad_loc_1 / DERIV_val(s);
            ad_adj_1 = 1.000000000000000e+00 / DERIV_val(s);
            ad_adj_2 =  -ad_adj_1;
            ad_grad_axpy_2(&(ad_var_11), ad_adj_2, &(A4), ad_adj_0, &(s));
            DERIV_val(ad_var_11) = ad_loc_1;
        }
     DERIV_val(q4coef) = exp( DERIV_val(ad_var_11));  /*exp*/
      ad_adji_0 = DERIV_val(q4coef);
        {
            ad_grad_axpy_1(&(q4coef), ad_adji_0, &(ad_var_11));
        }
    }
    else     {
        {
            ad_grad_axpy_0(&(q3));
            DERIV_val(q3) = 0.0;
        }
        {
            ad_grad_axpy_0(&(q4coef));
            DERIV_val(q4coef) = 0.0;
        }
    }
    {
        ad_grad_axpy_copy(&(data->q4), &(q4coef));
        DERIV_val(data->q4) = DERIV_val(q4coef);
    }
    for (ly = 0;     ly < 5;     )    {
        jy = ly + isuby * 5;
        {
            ad_loc_0 = jy - .5;
            ad_loc_1 = ad_loc_0 * DERIV_val(dely);
            ad_loc_2 = 30.0 + ad_loc_1;
            ad_grad_axpy_1(&(ydn), ad_loc_0, &(dely));
            DERIV_val(ydn) = ad_loc_2;
        }
        {
            ad_loc_0 = DERIV_val(ydn) + DERIV_val(dely);
            ad_grad_axpy_2(&(yup), 1.000000000000000e+00, &(ydn), 1.000000000000000e+00, &(dely));
            DERIV_val(yup) = ad_loc_0;
        }
        {
            ad_loc_0 = 0.2 * DERIV_val(ydn);
            ad_grad_axpy_1(&(ad_var_13), 2.000000000000000e-01, &(ydn));
            DERIV_val(ad_var_13) = ad_loc_0;
        }
     DERIV_val(ad_var_14) = exp( DERIV_val(ad_var_13));  /*exp*/
      ad_adji_0 = DERIV_val(ad_var_14);
        {
            ad_grad_axpy_1(&(ad_var_14), ad_adji_0, &(ad_var_13));
        }
        {
            ad_loc_0 = DERIV_val(verdco) * DERIV_val(ad_var_14);
            ad_grad_axpy_2(&(cydn), DERIV_val(ad_var_14), &(verdco), DERIV_val(verdco), &(ad_var_14));
            DERIV_val(cydn) = ad_loc_0;
        }
        {
            ad_loc_0 = 0.2 * DERIV_val(yup);
            ad_grad_axpy_1(&(ad_var_15), 2.000000000000000e-01, &(yup));
            DERIV_val(ad_var_15) = ad_loc_0;
        }
     DERIV_val(ad_var_16) = exp( DERIV_val(ad_var_15));  /*exp*/
      ad_adji_0 = DERIV_val(ad_var_16);
        {
            ad_grad_axpy_1(&(ad_var_16), ad_adji_0, &(ad_var_15));
        }
        {
            ad_loc_0 = DERIV_val(verdco) * DERIV_val(ad_var_16);
            ad_grad_axpy_2(&(cyup), DERIV_val(ad_var_16), &(verdco), DERIV_val(verdco), &(ad_var_16));
            DERIV_val(cyup) = ad_loc_0;
        }
        for (lx = 0;         lx < 5;         )        {
            jx = lx + isubx * 5;
            offsetue = (lx + 1) * 2 + (ly + 1) * nvmxsub2;
            {
                ad_grad_axpy_copy(&(c1), &(uext[offsetue]));
                DERIV_val(c1) = DERIV_val(uext[offsetue]);
            }
            {
                ad_grad_axpy_copy(&(c2), &(uext[offsetue + 1]));
                DERIV_val(c2) = DERIV_val(uext[offsetue + 1]);
            }
            {
                ad_loc_0 = DERIV_val(Q1) * DERIV_val(c1);
                ad_loc_1 = ad_loc_0 * DERIV_val(C3);
                ad_adj_0 = DERIV_val(Q1) * DERIV_val(C3);
                ad_adj_1 = DERIV_val(c1) * DERIV_val(C3);
                ad_grad_axpy_3(&(qq1), ad_adj_1, &(Q1), ad_adj_0, &(c1), ad_loc_0, &(C3));
                DERIV_val(qq1) = ad_loc_1;
            }
            {
                ad_loc_0 = DERIV_val(Q2) * DERIV_val(c1);
                ad_loc_1 = ad_loc_0 * DERIV_val(c2);
                ad_adj_0 = DERIV_val(Q2) * DERIV_val(c2);
                ad_adj_1 = DERIV_val(c1) * DERIV_val(c2);
                ad_grad_axpy_3(&(qq2), ad_adj_1, &(Q2), ad_adj_0, &(c1), ad_loc_0, &(c2));
                DERIV_val(qq2) = ad_loc_1;
            }
            {
                ad_loc_0 = DERIV_val(q3) * DERIV_val(C3);
                ad_grad_axpy_2(&(qq3), DERIV_val(C3), &(q3), DERIV_val(q3), &(C3));
                DERIV_val(qq3) = ad_loc_0;
            }
            {
                ad_loc_0 = DERIV_val(q4coef) * DERIV_val(c2);
                ad_grad_axpy_2(&(qq4), DERIV_val(c2), &(q4coef), DERIV_val(q4coef), &(c2));
                DERIV_val(qq4) = ad_loc_0;
            }
            {
                ad_loc_0 =  -DERIV_val(qq1);
                ad_loc_1 = ad_loc_0 - DERIV_val(qq2);
                ad_loc_2 = 2.0 * DERIV_val(qq3);
                ad_loc_3 = ad_loc_1 + ad_loc_2;
                ad_loc_4 = ad_loc_3 + DERIV_val(qq4);
                ad_grad_axpy_4(&(rkin1), -1.000000000000000e+00, &(qq1), -1.000000000000000e+00, &(qq2), 2.000000000000000e+00, &(qq3), 1.000000000000000e+00, &(qq4));
                DERIV_val(rkin1) = ad_loc_4;
            }
            {
                ad_loc_0 = DERIV_val(qq1) - DERIV_val(qq2);
                ad_loc_1 = ad_loc_0 - DERIV_val(qq4);
                ad_grad_axpy_3(&(rkin2), 1.000000000000000e+00, &(qq1), -1.000000000000000e+00, &(qq2), -1.000000000000000e+00, &(qq4));
                DERIV_val(rkin2) = ad_loc_1;
            }
            {
                ad_grad_axpy_copy(&(c1dn), &(uext[offsetue - nvmxsub2]));
                DERIV_val(c1dn) = DERIV_val(uext[offsetue - nvmxsub2]);
            }
            {
                ad_grad_axpy_copy(&(c2dn), &(uext[(offsetue - nvmxsub2) + 1]));
                DERIV_val(c2dn) = DERIV_val(uext[(offsetue - nvmxsub2) + 1]);
            }
            {
                ad_grad_axpy_copy(&(c1up), &(uext[offsetue + nvmxsub2]));
                DERIV_val(c1up) = DERIV_val(uext[offsetue + nvmxsub2]);
            }
            {
                ad_grad_axpy_copy(&(c2up), &(uext[(offsetue + nvmxsub2) + 1]));
                DERIV_val(c2up) = DERIV_val(uext[(offsetue + nvmxsub2) + 1]);
            }
            {
                ad_loc_0 = DERIV_val(c1up) - DERIV_val(c1);
                ad_loc_1 = DERIV_val(cyup) * ad_loc_0;
                ad_loc_2 = DERIV_val(c1) - DERIV_val(c1dn);
                ad_loc_3 = DERIV_val(cydn) * ad_loc_2;
                ad_loc_4 = ad_loc_1 - ad_loc_3;
                ad_adj_0 =  -DERIV_val(cydn);
                ad_adj_1 =  -ad_loc_2;
                ad_adj_2 =  -ad_adj_0;
                ad_adj_3 =  -DERIV_val(cyup);
                ad_grad_axpy_6(&(vertd1), ad_loc_0, &(cyup), DERIV_val(cyup), &(c1up), ad_adj_3, &(c1), ad_adj_1, &(cydn), ad_adj_0, &(c1), ad_adj_2, &(c1dn));
                DERIV_val(vertd1) = ad_loc_4;
            }
            {
                ad_loc_0 = DERIV_val(c2up) - DERIV_val(c2);
                ad_loc_1 = DERIV_val(cyup) * ad_loc_0;
                ad_loc_2 = DERIV_val(c2) - DERIV_val(c2dn);
                ad_loc_3 = DERIV_val(cydn) * ad_loc_2;
                ad_loc_4 = ad_loc_1 - ad_loc_3;
                ad_adj_0 =  -DERIV_val(cydn);
                ad_adj_1 =  -ad_loc_2;
                ad_adj_2 =  -ad_adj_0;
                ad_adj_3 =  -DERIV_val(cyup);
                ad_grad_axpy_6(&(vertd2), ad_loc_0, &(cyup), DERIV_val(cyup), &(c2up), ad_adj_3, &(c2), ad_adj_1, &(cydn), ad_adj_0, &(c2), ad_adj_2, &(c2dn));
                DERIV_val(vertd2) = ad_loc_4;
            }
            {
                ad_grad_axpy_copy(&(c1lt), &(uext[offsetue - 2]));
                DERIV_val(c1lt) = DERIV_val(uext[offsetue - 2]);
            }
            {
                ad_grad_axpy_copy(&(c2lt), &(uext[offsetue - 1]));
                DERIV_val(c2lt) = DERIV_val(uext[offsetue - 1]);
            }
            {
                ad_grad_axpy_copy(&(c1rt), &(uext[offsetue + 2]));
                DERIV_val(c1rt) = DERIV_val(uext[offsetue + 2]);
            }
            {
                ad_grad_axpy_copy(&(c2rt), &(uext[offsetue + 3]));
                DERIV_val(c2rt) = DERIV_val(uext[offsetue + 3]);
            }
            {
                ad_loc_0 = 2.0 * DERIV_val(c1);
                ad_loc_1 = DERIV_val(c1rt) - ad_loc_0;
                ad_loc_2 = ad_loc_1 + DERIV_val(c1lt);
                ad_loc_3 = DERIV_val(hordco) * ad_loc_2;
                ad_adj_0 =  -DERIV_val(hordco);
                ad_adj_1 = 2.0 * ad_adj_0;
                ad_grad_axpy_4(&(hord1), ad_loc_2, &(hordco), DERIV_val(hordco), &(c1rt), ad_adj_1, &(c1), DERIV_val(hordco), &(c1lt));
                DERIV_val(hord1) = ad_loc_3;
            }
            {
                ad_loc_0 = 2.0 * DERIV_val(c2);
                ad_loc_1 = DERIV_val(c2rt) - ad_loc_0;
                ad_loc_2 = ad_loc_1 + DERIV_val(c2lt);
                ad_loc_3 = DERIV_val(hordco) * ad_loc_2;
                ad_adj_0 =  -DERIV_val(hordco);
                ad_adj_1 = 2.0 * ad_adj_0;
                ad_grad_axpy_4(&(hord2), ad_loc_2, &(hordco), DERIV_val(hordco), &(c2rt), ad_adj_1, &(c2), DERIV_val(hordco), &(c2lt));
                DERIV_val(hord2) = ad_loc_3;
            }
            {
                ad_loc_0 = DERIV_val(c1rt) - DERIV_val(c1lt);
                ad_loc_1 = DERIV_val(horaco) * ad_loc_0;
                ad_adj_0 =  -DERIV_val(horaco);
                ad_grad_axpy_3(&(horad1), ad_loc_0, &(horaco), DERIV_val(horaco), &(c1rt), ad_adj_0, &(c1lt));
                DERIV_val(horad1) = ad_loc_1;
            }
            {
                ad_loc_0 = DERIV_val(c2rt) - DERIV_val(c2lt);
                ad_loc_1 = DERIV_val(horaco) * ad_loc_0;
                ad_adj_0 =  -DERIV_val(horaco);
                ad_grad_axpy_3(&(horad2), ad_loc_0, &(horaco), DERIV_val(horaco), &(c2rt), ad_adj_0, &(c2lt));
                DERIV_val(horad2) = ad_loc_1;
            }
            offsetu = lx * 2 + ly * nvmxsub;
            {
                ad_loc_0 = DERIV_val(vertd1) + DERIV_val(hord1);
                ad_loc_1 = ad_loc_0 + DERIV_val(horad1);
                ad_loc_2 = ad_loc_1 + DERIV_val(rkin1);
                ad_grad_axpy_4(&(duarray[offsetu]), 1.000000000000000e+00, &(vertd1), 1.000000000000000e+00, &(hord1), 1.000000000000000e+00, &(horad1), 1.000000000000000e+00, &(rkin1));
                DERIV_val(duarray[offsetu]) = ad_loc_2;
            }
            {
                ad_loc_0 = DERIV_val(vertd2) + DERIV_val(hord2);
                ad_loc_1 = ad_loc_0 + DERIV_val(horad2);
                ad_loc_2 = ad_loc_1 + DERIV_val(rkin2);
                ad_grad_axpy_4(&(duarray[offsetu + 1]), 1.000000000000000e+00, &(vertd2), 1.000000000000000e+00, &(hord2), 1.000000000000000e+00, &(horad2), 1.000000000000000e+00, &(rkin2));
                DERIV_val(duarray[offsetu + 1]) = ad_loc_2;
            }
            ad_var_17 = lx++;
        }
        ad_var_12 = ly++;
    }
}
void   ad_ucomm(integer  N,nosens_real  t,ad_N_Vector  u,void   *f_data) {
}
void   ad_AD_Init(int  arg0) {
    ad_AD_GradInit(arg0);

}
void   ad_AD_Final() {
    ad_AD_GradFinal();

}
