#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "nvector.h"   /* definitions of type N_Vector, macro N_VDATA     */
#include "llnltyps.h"  /* definitions of real, integer, TRUE, FALSE       */
#include "llnlmath.h"  /* contains SQR macro                              */
#include "mpi.h"       /* MPI data types and prototypes                   */
#include "diurnal_func.h"
#include "ad_support.h"

void ad_copy_data(UserData data, ad_UserData ad_data, int ns) {
int i,j;

for (i=0;i<NP;i++)
  {
    DERIV_val(ad_data->p[i]) = data->p[i];
    DERIV_val(ad_data->pbar[i]) = data->pbar[i];
  }

for(i=0;i<NP;i++){
  for(j=0;j<ns;j++) DERIV_grad(ad_data->p[i])[j] = 0;
  for(j=0;j<ns;j++) DERIV_grad(ad_data->pbar[i])[j] = 0;
}

DERIV_val(ad_data->om) = data->om;
DERIV_val(ad_data->dx) = data->dx;
DERIV_val(ad_data->dy) = data->dy;
DERIV_val(ad_data->q4) = data->q4;

/* to be on the safe side */
for(j=0;j<ns;j++) DERIV_grad(ad_data->om)[j] = 0;
for(j=0;j<ns;j++) DERIV_grad(ad_data->dx)[j] = 0;
for(j=0;j<ns;j++) DERIV_grad(ad_data->dy)[j] = 0;
for(j=0;j<ns;j++) DERIV_grad(ad_data->q4)[j] = 0;

ad_data->my_pe = data->my_pe;
ad_data->isubx = data->isubx;
ad_data->isuby = data->isuby;
ad_data->nvmxsub = data->nvmxsub;
ad_data->nvmxsub2 = data->nvmxsub2;
ad_data->comm = data->comm;

}

